Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_min.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_min.cfg	(revision 111)
@@ -4,4 +4,5 @@
 1	1	*2	# nb_rename_unit          
 1	1	*2	# size_queue              
+0       1       +1      # queue_scheme
 1	1	*2	# nb_bank                 
 0	0	*2	# size_packet             
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_mono_rename_unit.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_mono_rename_unit.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_mono_rename_unit.cfg	(revision 111)
@@ -4,4 +4,5 @@
 1	1	*2	# nb_rename_unit          
 16	32	*2	# size_queue              
+0       1       +1      # queue_scheme
 4	16	*2	# nb_bank                 
 0	0	*2	# size_packet             
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_multi_rename_unit.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_multi_rename_unit.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/config_multi_rename_unit.cfg	(revision 111)
@@ -4,4 +4,5 @@
 4	4	*2	# nb_rename_unit          
 64	64	*2	# size_queue              
+0       1       +1      # queue_scheme
 4	16	*2	# nb_bank                 
 0	0	*2	# size_packet             
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/src/main.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/src/main.cpp	(revision 111)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/SelfTest/include/test.h"
 
-#define NB_PARAMS 17
+#define NB_PARAMS 18
 
 void usage (int argc, char * argv[])
@@ -14,24 +14,25 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * nb_context                                            (uint32_t         )\n"));
-  err (_(" * nb_front_end                                          (uint32_t         )\n"));
-  err (_(" * nb_rename_unit                                        (uint32_t         )\n"));
-  err (_(" * size_queue                                            (uint32_t         )\n"));
-  err (_(" * nb_bank                                               (uint32_t         )\n"));
-  err (_(" * size_packet                                           (uint32_t         )\n"));
-  err (_(" * size_general_data                                     (uint32_t         )\n"));
-  err (_(" * size_special_data                                     (uint32_t         )\n"));
-  err (_(" * size_general_register                                 (uint32_t         )\n"));
-  err (_(" * size_special_register                                 (uint32_t         )\n"));
-  err (_(" * size_store_queue_ptr                                  (uint32_t         )\n"));
-  err (_(" * size_load_queue_ptr                                   (uint32_t         )\n"));
-  err (_(" * nb_inst_issue                                         (uint32_t         )\n"));
-  err (_(" * nb_inst_rename        [nb_rename_unit]                (uint32_t         )\n"));
-  err (_(" * nb_inst_reexecute                                     (uint32_t         )\n"));
-  err (_(" * nb_rename_unit_select                                 (uint32_t         )\n"));
-  err (_(" * priority                                              (Tpriority_t      )\n"));
-  err (_(" * load_balancing                                        (Tload_balancing_t)\n"));
-  err (_(" * table_routing         [nb_rename_unit][nb_inst_issue] (bool             )\n"));
-  err (_(" * table_routing         [nb_inst_issue][nb_type]        (bool             )\n"));
+  err (_(" * nb_context                                            (uint32_t             )\n"));
+  err (_(" * nb_front_end                                          (uint32_t             )\n"));
+  err (_(" * nb_rename_unit                                        (uint32_t             )\n"));
+  err (_(" * size_queue                                            (uint32_t             )\n"));
+  err (_(" * queue_scheme                                          (Tissue_queue_scheme_t)\n"));
+  err (_(" * nb_bank                                               (uint32_t             )\n"));
+  err (_(" * size_packet                                           (uint32_t             )\n"));
+  err (_(" * size_general_data                                     (uint32_t             )\n"));
+  err (_(" * size_special_data                                     (uint32_t             )\n"));
+  err (_(" * size_general_register                                 (uint32_t             )\n"));
+  err (_(" * size_special_register                                 (uint32_t             )\n"));
+  err (_(" * size_store_queue_ptr                                  (uint32_t             )\n"));
+  err (_(" * size_load_queue_ptr                                   (uint32_t             )\n"));
+  err (_(" * nb_inst_issue                                         (uint32_t             )\n"));
+  err (_(" * nb_inst_rename        [nb_rename_unit]                (uint32_t             )\n"));
+  err (_(" * nb_inst_reexecute                                     (uint32_t             )\n"));
+  err (_(" * nb_rename_unit_select                                 (uint32_t             )\n"));
+  err (_(" * priority                                              (Tpriority_t          )\n"));
+  err (_(" * load_balancing                                        (Tload_balancing_t    )\n"));
+  err (_(" * table_routing         [nb_rename_unit][nb_inst_issue] (bool                 )\n"));
+  err (_(" * table_routing         [nb_inst_issue][nb_type]        (bool                 )\n"));
   err (_("   * TYPE_ALU    \n"));
   err (_("   * TYPE_SHIFT  \n"));
@@ -71,4 +72,5 @@
 
   uint32_t          _size_queue             = fromString<uint32_t         >(argv[x++]);
+  Tissue_queue_scheme_t _queue_scheme       = fromString<Tissue_queue_scheme_t>(argv[x++]);
   uint32_t          _nb_bank                = fromString<uint32_t         >(argv[x++]);
   uint32_t          _size_packet            = fromString<uint32_t         >(argv[x++]);
@@ -126,4 +128,5 @@
 	 _nb_rename_unit        ,
 	 _size_queue            ,
+         _queue_scheme          ,
 	 _nb_bank               ,
 	 _size_packet           ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h	(revision 111)
@@ -139,16 +139,22 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
   private   : generic::priority::Priority   * _priority_in ;
+
+    // in_order implementation only
+    // out_of_order implementation only
+  private   : generic::priority::Priority   * _priority_reg;
   private   : generic::priority::Priority   * _priority_out;
-  private   : generic::priority::Priority   * _priority_reg;
 
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    // common implementation
   private   : std::list<entry_t*>           * _issue_queue;
   private   : std::list<entry_t*>             _reexecute_queue;
+
+    // in_order implementation only
+  private   : uint32_t                        reg_NUM_BANK_HEAD;
+  private   : uint32_t                        reg_NUM_BANK_TAIL;
+    // out_of_order implementation only
   
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  private   : Tcontrol_t                    * internal_BANK_IN_ACK              ;//[nb_bank]
-  private   : uint32_t                      * internal_BANK_IN_NUM_RENAME_UNIT  ;//[nb_bank]
-  private   : uint32_t                      * internal_BANK_IN_NUM_INST         ;//[nb_bank]
-
+    // common implementation
   private   : Tcontrol_t                    * internal_ISSUE_OUT_VAL            ;//[nb_inst_issue]
   private   : Tcontrol_t                    * internal_ISSUE_OUT_FROM_REEXECUTE ;//[nb_inst_issue]
@@ -157,4 +163,17 @@
 
   private   : Tcontrol_t                    * internal_REEXECUTE_ACK            ;//[nb_inst_reexecute]
+
+    // in_order implementation only
+  private   : Tcontrol_t                    * internal_BANK_IN_ACK              ;//[nb_bank]
+  private   : uint32_t                      * internal_BANK_IN_NUM_RENAME_UNIT  ;//[nb_bank]
+  private   : uint32_t                      * internal_BANK_IN_NUM_INST         ;//[nb_bank]
+    // out_of_order implementation only
+  public    : Tcontrol_t                   ** internal_ISSUE_IN_ACK             ;//[nb_rename_unit][nb_inst_rename]
+
+    // function pointer
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::*function_transition) (void);
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::*function_genMoore  ) (void);
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::*function_genMealy_issue_in ) (void);
+  public    : void (morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::*function_genMealy_issue_out) (void);
 #endif
 
@@ -189,6 +208,15 @@
 					       
 #ifdef SYSTEMC				       
-  public  : void        transition                (void);
-  public  : void        genMoore                  (void);
+  public  : void        transition                          (void);
+  public  : void        genMoore                            (void);
+  public  : void        genMealy_issue_in                   (void);
+  public  : void        genMealy_issue_out                  (void);
+
+  public  : void        function_in_order_transition        (void);
+  public  : void        function_in_order_genMealy_issue_out(void);
+  public  : void        function_in_order_genMoore          (void);
+
+  public  : void        function_out_of_order_transition    (void);
+  public  : void        function_out_of_order_genMoore      (void);
 #endif					       
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Parameters.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Parameters.h	(revision 111)
@@ -25,60 +25,62 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t          _nb_context              ;
-  public : uint32_t          _nb_front_end            ;
-  public : uint32_t          _nb_rename_unit          ;
-  public : uint32_t          _size_queue              ;
-  public : uint32_t          _nb_bank                 ;
-//public : uint32_t          _size_packet             ;
-//public : uint32_t          _size_general_data       ;
-//public : uint32_t          _size_special_data       ;
-//public : uint32_t          _size_general_register   ;
-//public : uint32_t          _size_special_register   ;
-//public : uint32_t          _size_store_queue_ptr    ;
-//public : uint32_t          _size_load_queue_ptr     ;
-  public : uint32_t          _nb_inst_issue           ;
-  public : uint32_t        * _nb_inst_rename          ;//[nb_rename_unit]
-  public : uint32_t          _nb_inst_reexecute       ;
-  public : uint32_t          _nb_rename_unit_select   ;
-  public : Tpriority_t       _priority                ;
-  public : Tload_balancing_t _load_balancing          ;
-  public : bool           ** _table_routing           ;//[nb_rename_unit][nb_inst_issue]
-  public : bool           ** _table_issue_type        ;//[nb_inst_issue][nb_type]
-  public : uint32_t          _size_reexecute_queue    ;
-
-//public : uint32_t          _nb_bank_select_out      ;
-  public : uint32_t          _max_nb_inst_rename      ;
-
-//public : uint32_t          _size_context_id         ;
-//public : uint32_t          _size_front_end_id       ;
-  public : uint32_t          _size_bank               ;
-
-//public : bool              _have_port_context_id    ;
-//public : bool              _have_port_front_end_id  ;
-//public : bool              _have_port_packet_id     ;
-//public : bool              _have_port_load_queue_ptr;
+  public : uint32_t              _nb_context              ;
+  public : uint32_t              _nb_front_end            ;
+  public : uint32_t              _nb_rename_unit          ;
+  public : uint32_t              _size_queue              ;
+  public : Tissue_queue_scheme_t _queue_scheme            ;
+  public : uint32_t              _nb_bank                 ;
+//public : uint32_t              _size_packet             ;
+//public : uint32_t              _size_general_data       ;
+//public : uint32_t              _size_special_data       ;
+//public : uint32_t              _size_general_register   ;
+//public : uint32_t              _size_special_register   ;
+//public : uint32_t              _size_store_queue_ptr    ;
+//public : uint32_t              _size_load_queue_ptr     ;
+  public : uint32_t              _nb_inst_issue           ;
+  public : uint32_t            * _nb_inst_rename          ;//[nb_rename_unit]
+  public : uint32_t              _nb_inst_reexecute       ;
+  public : uint32_t              _nb_rename_unit_select   ;
+  public : Tpriority_t           _priority                ;
+  public : Tload_balancing_t     _load_balancing          ;
+  public : bool               ** _table_routing           ;//[nb_rename_unit][nb_inst_issue]
+  public : bool               ** _table_issue_type        ;//[nb_inst_issue][nb_type]
+  public : uint32_t              _size_reexecute_queue    ;
+                             
+//public : uint32_t              _nb_bank_select_out      ;
+  public : uint32_t              _max_nb_inst_rename      ;
+                             
+//public : uint32_t              _size_context_id         ;
+//public : uint32_t              _size_front_end_id       ;
+  public : uint32_t              _size_bank               ;
+                             
+//public : bool                  _have_port_context_id    ;
+//public : bool                  _have_port_front_end_id  ;
+//public : bool                  _have_port_packet_id     ;
+//public : bool                  _have_port_load_queue_ptr;
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t          nb_context              ,
-			uint32_t          nb_front_end            ,
-			uint32_t          nb_rename_unit          ,
-			uint32_t          size_queue              ,
-			uint32_t          nb_bank                 ,
-			uint32_t          size_packet             ,
-			uint32_t          size_general_data       ,
-			uint32_t          size_special_data       ,
-			uint32_t          size_general_register   ,
-			uint32_t          size_special_register   ,
-			uint32_t          size_store_queue_ptr    ,
-			uint32_t          size_load_queue_ptr     ,
-			uint32_t          nb_inst_issue           ,
-			uint32_t        * nb_inst_rename          ,
-			uint32_t          nb_inst_reexecute       ,
-			uint32_t          nb_rename_unit_select   ,
-			Tpriority_t       priority                ,
-			Tload_balancing_t load_balancing          ,
-			bool           ** table_routing           ,
-			bool           ** table_issue_type        ,
-                        bool              is_toplevel=false);
+  public : Parameters  (uint32_t              nb_context              ,
+			uint32_t              nb_front_end            ,
+			uint32_t              nb_rename_unit          ,
+			uint32_t              size_queue              ,
+                        Tissue_queue_scheme_t queue_scheme            ,
+			uint32_t              nb_bank                 ,
+			uint32_t              size_packet             ,
+			uint32_t              size_general_data       ,
+			uint32_t              size_special_data       ,
+			uint32_t              size_general_register   ,
+			uint32_t              size_special_register   ,
+			uint32_t              size_store_queue_ptr    ,
+			uint32_t              size_load_queue_ptr     ,
+			uint32_t              nb_inst_issue           ,
+			uint32_t            * nb_inst_rename          ,
+			uint32_t              nb_inst_reexecute       ,
+			uint32_t              nb_rename_unit_select   ,
+			Tpriority_t           priority                ,
+			Tload_balancing_t     load_balancing          ,
+			bool               ** table_routing           ,
+			bool               ** table_issue_type        ,
+                        bool                  is_toplevel=false);
 
 //   public : Parameters  (Parameters & param) ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Types.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Types.h	(revision 111)
@@ -17,4 +17,11 @@
 namespace ooo_engine {
 namespace issue_queue {
+
+  typedef enum 
+    {
+       ISSUE_QUEUE_SCHEME_IN_ORDER        // Each instruction is issue in of order
+//       ,ISSUE_QUEUE_SCHEME_IN_BUNDLE_ORDER // Each bundle is issue in order. In bundle, an instruction is issue out of order
+      ,ISSUE_QUEUE_SCHEME_OUT_OF_ORDER    // Each instruction is issue out of order
+    } Tissue_queue_scheme_t;
 
   class entry_t
@@ -87,4 +94,32 @@
 }; // end namespace core
 }; // end namespace behavioural
+
+  template<> inline std::string toString<morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Tissue_queue_scheme_t>(const morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Tissue_queue_scheme_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_ORDER        : return "in_order"       ; break;
+//       case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_BUNDLE_ORDER : return "in_bundle_order"; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_OUT_OF_ORDER    : return "out_of_order"   ; break;
+      default : return ""; break;
+      }
+  };
+
+  template<> inline morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Tissue_queue_scheme_t fromString<morpheo::behavioural::core::multi_ooo_engine
+::ooo_engine::issue_queue::Tissue_queue_scheme_t>(const std::string& x)
+  {
+    if ( (x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_ORDER))) == 0) or
+         (x.compare("in_order")        == 0))
+      return morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_ORDER;
+//     if ( (x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_BUNDLE_ORDER))) == 0) or
+//          (x.compare("in_bundle_order") == 0))
+//       return morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_IN_BUNDLE_ORDER;
+    if ( (x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_OUT_OF_ORDER))) == 0) or
+         (x.compare("out_of_order")    == 0))
+      return morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::ISSUE_QUEUE_SCHEME_OUT_OF_ORDER;
+    
+    throw (ErrorMorpheo ("<fromString> : Unknow string : \""+x+"\""));
+  };
+
 }; // end namespace morpheo              
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue.cpp	(revision 111)
@@ -75,23 +75,88 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-	log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+        // Function pointer
+        switch (_param->_queue_scheme)
+          {
+          case ISSUE_QUEUE_SCHEME_IN_ORDER        :
+            {
+              function_transition         = &morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::function_in_order_transition        ;
+              function_genMoore           = &morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::function_in_order_genMoore          ;
+              function_genMealy_issue_in  = NULL;
+              function_genMealy_issue_out = &morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::function_in_order_genMealy_issue_out;
+              
+              break;
+            }
+          case ISSUE_QUEUE_SCHEME_OUT_OF_ORDER    :
+            {
+              function_transition         = &morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::function_out_of_order_transition        ;
+              function_genMoore           = &morpheo::behavioural::core::multi_ooo_engine::ooo_engine::issue_queue::Issue_queue::function_out_of_order_genMoore          ;
+              function_genMealy_issue_in  = NULL;
+              function_genMealy_issue_out = NULL;
+              
+              break;
+            }
+          default :
+            {
+              break;
+            }
+          }
 
-	SC_METHOD (transition);
-	dont_initialize ();
-	sensitive << (*(in_CLOCK)).pos();
-	
+        if (function_transition != NULL)
+          {
+            log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+            
+            SC_METHOD (transition);
+            dont_initialize ();
+            sensitive << (*(in_CLOCK)).pos();
+            
 # ifdef SYSTEMCASS_SPECIFIC
-	// List dependency information
+            // List dependency information
 # endif    
+          }
 
-	log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - genMoore"),_name.c_str());
+        if (function_genMoore != NULL)
+          {
+            log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - genMoore"),_name.c_str());
+            
+            SC_METHOD (genMoore);
+            dont_initialize ();
+            sensitive << (*(in_CLOCK)).neg(); // need internal register
+            
+# ifdef SYSTEMCASS_SPECIFIC
+            // List dependency information
+# endif    
+          }
 
-	SC_METHOD (genMoore);
-	dont_initialize ();
-	sensitive << (*(in_CLOCK)).neg(); // need internal register
-	
+        if (function_genMealy_issue_in != NULL)
+          {
+            log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - genMealy_issue_in"),_name.c_str());
+            
+            SC_METHOD (genMealy_issue_in);
+            dont_initialize ();
+            sensitive << (*(in_CLOCK)).neg(); // need internal register
+            
 # ifdef SYSTEMCASS_SPECIFIC
-	// List dependency information
+            // List dependency information
 # endif    
+          }
+
+        if (function_genMealy_issue_out != NULL)
+          {
+            log_printf(INFO,Issue_queue,FUNCTION,_("<%s> : Method - genMealy_issue_out"),_name.c_str());
+            
+            SC_METHOD (genMealy_issue_out);
+            dont_initialize ();
+            sensitive << (*(in_CLOCK)).neg(); // need internal register
+
+            if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_IN_ORDER)
+              {
+                for (uint32_t i=0; i<_param->_nb_inst_issue; ++i)
+                  sensitive << (*(in_ISSUE_OUT_ACK [i]));
+              }
+            
+# ifdef SYSTEMCASS_SPECIFIC
+            // List dependency information
+# endif    
+          }
 
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_allocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_allocation.cpp	(revision 111)
@@ -154,8 +154,18 @@
 
     ALLOC1(internal_REEXECUTE_ACK           ,Tcontrol_t,_param->_nb_inst_reexecute);
+
+    if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_OUT_OF_ORDER)
+      {
+    ALLOC1(internal_BANK_IN_ACK             ,Tcontrol_t,_param->_nb_bank);
+    ALLOC1(internal_BANK_IN_NUM_RENAME_UNIT ,uint32_t  ,_param->_nb_bank);
+    ALLOC1(internal_BANK_IN_NUM_INST        ,uint32_t  ,_param->_nb_bank);
+      }
+    if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_IN_ORDER)
+      {
+    ALLOC2(internal_ISSUE_IN_ACK            ,Tcontrol_t,_param->_nb_rename_unit,_param->_nb_inst_rename[it1]);
+      }
       }
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-
     _priority_in  = new generic::priority::Priority (_name+"_priority_in"   ,
 						     _param->_priority      ,
@@ -165,4 +175,6 @@
 						     _param->_nb_rename_unit_select);
 
+    if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_OUT_OF_ORDER)
+      {
     _priority_out = new generic::priority::Priority (_name+"_priority_out"  ,
 						     _param->_priority      ,
@@ -174,4 +186,5 @@
 						     _param->_nb_bank,
 						     _param->_nb_bank);
+      }
 
 #ifdef POSITION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_deallocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_deallocation.cpp	(revision 111)
@@ -98,8 +98,4 @@
         
         // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-        DELETE1(internal_BANK_IN_ACK             ,_param->_nb_bank);
-        DELETE1(internal_BANK_IN_NUM_RENAME_UNIT ,_param->_nb_bank);
-        DELETE1(internal_BANK_IN_NUM_INST        ,_param->_nb_bank);
-
         DELETE1(internal_ISSUE_OUT_VAL           ,_param->_nb_inst_issue);
         DELETE1(internal_ISSUE_OUT_FROM_REEXECUTE,_param->_nb_inst_issue);
@@ -108,4 +104,15 @@
 
         DELETE1(internal_REEXECUTE_ACK           ,_param->_nb_inst_reexecute);
+
+        if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_OUT_OF_ORDER)
+          {
+        DELETE1(internal_BANK_IN_ACK             ,_param->_nb_bank);
+        DELETE1(internal_BANK_IN_NUM_RENAME_UNIT ,_param->_nb_bank);
+        DELETE1(internal_BANK_IN_NUM_INST        ,_param->_nb_bank);
+          }
+        if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_IN_ORDER)
+          {
+        DELETE2(internal_ISSUE_IN_ACK            ,_param->_nb_rename_unit,_param->_nb_inst_rename[it1]);
+          }
       }
     
@@ -113,6 +120,9 @@
     
     delete    _priority_in ;
-    delete    _priority_out;
-    delete    _priority_reg;
+    if (_param->_queue_scheme == ISSUE_QUEUE_SCHEME_OUT_OF_ORDER)
+      {
+        delete    _priority_out;
+        delete    _priority_reg;
+      }
     delete    _component;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMealy_issue_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMealy_issue_out.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMealy_issue_out.cpp	(revision 111)
@@ -0,0 +1,172 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::function_in_order_genMealy_issue_out"
+  void Issue_queue::function_in_order_genMealy_issue_out (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    // ===================================================================
+    // =====[ ISSUE_OUT ]=================================================
+    // ===================================================================
+    {
+      Tcontrol_t val [_param->_nb_inst_issue];
+
+      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+        val [i] = 0;
+
+      // From Reexecute_queue
+
+//       uint32_t num_reexecute_entry = 0;
+      for (std::list<entry_t*>::iterator it=_reexecute_queue.begin();
+           it!=_reexecute_queue.end();
+           ++it)
+        {
+          entry_t* entry = (*it);
+
+          for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+            // test if no previous transaction and can accept this type
+            if ((val[i] == 0) and _param->_table_issue_type [i][entry->_type])
+              {
+                // find a issue port
+                val [i] = 1;
+	    
+                if (_param->_have_port_context_id)
+	        PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
+	        if (_param->_have_port_front_end_id)
+	        PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
+	        if (_param->_have_port_rob_ptr  )
+	        PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
+	        PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
+	        PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
+	        PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
+	        if (_param->_have_port_load_queue_ptr)
+	        PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
+	        PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
+	        PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
+	        PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
+	        PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
+
+                internal_ISSUE_OUT_FROM_REEXECUTE [i] = true;
+//              internal_ISSUE_OUT_NUM_BANK       [i] = num_reexecute_entry;
+                internal_ISSUE_OUT_ENTRY          [i] = entry;
+
+                break; // stop scan
+              }
+//           num_reexecute_entry ++;
+        }
+
+      // From Issue_queue
+      for (uint32_t i=0; i<_param->_nb_bank; ++i)
+        {
+          uint32_t num_bank=(reg_NUM_BANK_HEAD+i)%_param->_nb_bank;
+          
+          log_printf(TRACE,Issue_queue,FUNCTION,"    * Bank [%d]",num_bank);
+          
+          bool find = false;
+          
+          // Have instruction ?
+          if (not _issue_queue [num_bank].empty())
+            {
+ 	      log_printf(TRACE,Issue_queue,FUNCTION,"      * Not Empty !!!");
+
+              entry_t* entry = _issue_queue [num_bank].front();
+              
+              for (uint32_t j=0; j<_param->_nb_inst_issue; j++)
+                {
+                  log_printf(TRACE,Issue_queue,FUNCTION,"    * Issue [%d]",j);
+                  log_printf(TRACE,Issue_queue,FUNCTION,"      * issue_ack            : %d",PORT_READ(in_ISSUE_OUT_ACK [j]));
+                  log_printf(TRACE,Issue_queue,FUNCTION,"      * previous transaction : %d",val[j]);
+                  log_printf(TRACE,Issue_queue,FUNCTION,"      * can issue type       : %d",_param->_table_issue_type [j][entry->_type]);
+
+                  // test if no previous transaction and can accept this type
+                  if ((val[j] == 0) and 
+                      _param->_table_issue_type [j][entry->_type] and
+                      PORT_READ(in_ISSUE_OUT_ACK [j]))
+                    {
+                      log_printf(TRACE,Issue_queue,FUNCTION,"    * find : %d",j);
+                      
+                      // find a issue port
+                      val [j] = 1;
+                      
+                      if (_param->_have_port_context_id)
+	              PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [j], entry->_context_id           );
+	              if (_param->_have_port_front_end_id)
+	              PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [j], entry->_front_end_id         );
+	              if (_param->_have_port_rob_ptr  )
+	              PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [j], entry->_packet_id            );
+	              PORT_WRITE(out_ISSUE_OUT_OPERATION             [j], entry->_operation            );
+	              PORT_WRITE(out_ISSUE_OUT_TYPE                  [j], entry->_type                 );
+	              PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [j], entry->_store_queue_ptr_write);
+	              if (_param->_have_port_load_queue_ptr)
+	              PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [j], entry->_load_queue_ptr_write );
+	              PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [j], entry->_has_immediat         );
+	              PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [j], entry->_immediat             );
+	              PORT_WRITE(out_ISSUE_OUT_READ_RA               [j], entry->_read_ra              );
+	              PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [j], entry->_num_reg_ra           );
+	              PORT_WRITE(out_ISSUE_OUT_READ_RB               [j], entry->_read_rb              );
+	              PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [j], entry->_num_reg_rb           );
+	              PORT_WRITE(out_ISSUE_OUT_READ_RC               [j], entry->_read_rc              );
+	              PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [j], entry->_num_reg_rc           );
+	              PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [j], entry->_write_rd             );
+	              PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [j], entry->_num_reg_rd           );
+	              PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [j], entry->_write_re             );
+	              PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [j], entry->_num_reg_re           );
+                      
+                      internal_ISSUE_OUT_FROM_REEXECUTE [j] = false;
+                      internal_ISSUE_OUT_NUM_BANK       [j] = num_bank;
+                      internal_ISSUE_OUT_ENTRY          [j] = entry;
+                      
+                      find = true;
+                      break; // find : stop scan
+                    }
+                }
+            }
+
+          if (not find)
+            break; // stop scan (in order)
+        }
+
+      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+        {
+          internal_ISSUE_OUT_VAL [i] = val [i];
+          PORT_WRITE(out_ISSUE_OUT_VAL [i], internal_ISSUE_OUT_VAL [i]);
+        }
+    }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMoore.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_genMoore.cpp	(revision 111)
@@ -0,0 +1,80 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::function_in_order_genMoore"
+  void Issue_queue::function_in_order_genMoore (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    // ===================================================================
+    // =====[ REEXECUTE_UNIT ]============================================
+    // ===================================================================
+    // Same implementation in in-order and out-of-order
+
+    // ===================================================================
+    // =====[ ISSUE_IN ]==================================================
+    // ===================================================================
+    {
+      // init
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
+          internal_ISSUE_IN_ACK [i][j] = false;
+
+      std::list<generic::priority::select_t> * select_in = _priority_in ->select(); // same select for all issue
+      std::list<generic::priority::select_t>::iterator it=select_in ->begin();
+
+      uint32_t num_bank = reg_NUM_BANK_TAIL;
+      uint32_t nb_insert = 0;
+      while ((it!=select_in ->end()) and  
+             (_issue_queue[num_bank].size() != _param->_size_bank) and // test if can accept an data
+             (nb_insert < _param->_nb_bank)
+             )
+        {
+          // Get num interface
+          uint32_t num_rename_unit = it->grp;
+          uint32_t num_inst_rename = it->elt;
+          
+          log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d][%d]",num_rename_unit,num_inst_rename);
+          
+          // find
+          internal_ISSUE_IN_ACK [num_rename_unit][num_inst_rename] = true;
+
+          // update pointer
+          ++it;
+          num_bank = (num_bank+1)%_param->_nb_bank;
+          nb_insert ++;
+        }
+      
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
+          PORT_WRITE(out_ISSUE_IN_ACK [i][j],internal_ISSUE_IN_ACK [i][j]);
+    }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_in_order_transition.cpp	(revision 111)
@@ -0,0 +1,124 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::function_in_order_transition"
+  void Issue_queue::function_in_order_transition (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+// 	_priority_in ->reset();
+// 	_priority_out->reset();
+// 	_priority_reg->reset();
+	
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  _issue_queue [i].clear();
+
+        reg_NUM_BANK_HEAD = 0;
+        reg_NUM_BANK_TAIL = 0;
+      }
+    else
+      {
+// 	_priority_in ->transition();
+// 	_priority_out->transition();
+// 	_priority_reg->transition();
+
+	// ===================================================================
+	// =====[ ISSUE_IN ]==================================================
+	// ===================================================================
+        {
+          for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+            for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
+              if (PORT_READ(in_ISSUE_IN_VAL[i][j]) and internal_ISSUE_IN_ACK [i][j])
+                {
+                  uint32_t num_bank = reg_NUM_BANK_TAIL;
+                  
+                  log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d][%d] - Transaction with bank [%d]",i,j,num_bank);
+                      
+#ifdef STATISTICS
+                  if (usage_is_set(_usage,USE_STATISTICS))
+                    (*_stat_nb_inst_issue_in [i]) ++;
+#endif
+                  entry_t * entry = new entry_t
+                    (
+                     (_param->_have_port_context_id    )?PORT_READ(in_ISSUE_IN_CONTEXT_ID            [i][j]):0,
+                     (_param->_have_port_front_end_id  )?PORT_READ(in_ISSUE_IN_FRONT_END_ID          [i][j]):0,
+                     (_param->_have_port_rob_ptr       )?PORT_READ(in_ISSUE_IN_PACKET_ID             [i][j]):0,
+		                                         PORT_READ(in_ISSUE_IN_OPERATION             [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_TYPE                  [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_STORE_QUEUE_PTR_WRITE [i][j]),
+                     (_param->_have_port_load_queue_ptr)?PORT_READ(in_ISSUE_IN_LOAD_QUEUE_PTR_WRITE  [i][j]):0,
+		                                         PORT_READ(in_ISSUE_IN_HAS_IMMEDIAT          [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_IMMEDIAT              [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_READ_RA               [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_NUM_REG_RA            [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_READ_RB               [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_NUM_REG_RB            [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_READ_RC               [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_NUM_REG_RC            [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_WRITE_RD              [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_NUM_REG_RD            [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_WRITE_RE              [i][j]),
+		                                         PORT_READ(in_ISSUE_IN_NUM_REG_RE            [i][j])
+                     );
+                    
+                  _issue_queue [num_bank].push_back(entry);
+                  
+                  // Update pointer
+                  reg_NUM_BANK_TAIL = (reg_NUM_BANK_TAIL+1)%_param->_nb_bank;
+                }
+        }
+
+	// ===================================================================
+	// =====[ ISSUE_OUT ]=================================================
+	// ===================================================================
+
+        for (uint32_t i=0; i<_param->_nb_inst_issue; ++i)
+          if (internal_ISSUE_OUT_VAL [i] and PORT_READ(in_ISSUE_OUT_ACK [i]))
+            if (not internal_ISSUE_OUT_FROM_REEXECUTE [i])
+              {
+                entry_t * entry = internal_ISSUE_OUT_ENTRY    [i];
+                
+                // front ...
+                uint32_t  num_bank = internal_ISSUE_OUT_NUM_BANK [i];
+                
+                log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_OUT [%d] - From issue_queue [%d]",i,num_bank);
+                
+                _issue_queue [num_bank].remove(entry);
+                
+                reg_NUM_BANK_HEAD = (reg_NUM_BANK_HEAD+1)%_param->_nb_bank;
+                
+                delete entry;
+              } 
+
+      }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_genMoore.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_genMoore.cpp	(revision 111)
@@ -0,0 +1,225 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::function_out_of_order_genMoore"
+  void Issue_queue::function_out_of_order_genMoore (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    // ===================================================================
+    // =====[ REEXECUTE_UNIT ]============================================
+    // ===================================================================
+    // Same implementation in in-order and out-of-order
+
+    // ===================================================================
+    // =====[ ISSUE_IN ]==================================================
+    // ===================================================================
+    {
+      Tcontrol_t ack [_param->_nb_rename_unit][_param->_max_nb_inst_rename];
+
+      // Initialisation
+      for (uint32_t i=0; i<_param->_nb_bank; i++)
+        internal_BANK_IN_ACK  [i] = false;
+    
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
+          ack [i][j] = false;
+    
+      std::list<generic::priority::select_t> * select_reg = _priority_reg->select(); // same select for all issue
+      
+      // issue_in interface
+      std::list<generic::priority::select_t> * select_in = _priority_in ->select(); // same select for all issue
+      for (std::list<generic::priority::select_t>::iterator it=select_in ->begin();
+           it!=select_in ->end();
+           it++)
+        {
+          // Get num interface
+          uint32_t num_rename_unit = it->grp;
+          uint32_t num_inst_rename = it->elt;
+
+          log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d][%d]",num_rename_unit,num_inst_rename);
+          
+          // scan all bank
+          for (std::list<generic::priority::select_t>::iterator it=select_reg->begin();
+               it!=select_reg->end();
+               it++)
+            {
+              uint32_t num_bank  = it->grp;
+
+              log_printf(TRACE,Issue_queue,FUNCTION,"    * BANK [%d]",num_bank);
+          
+              // test if bank is not busy (full or previous access)
+              if (not internal_BANK_IN_ACK [num_bank] and (_issue_queue[num_bank].size() < _param->_size_bank))
+                {
+                  log_printf(TRACE,Issue_queue,FUNCTION,"    * find");
+
+                  // find
+                  ack [num_rename_unit][num_inst_rename] = true;
+                  internal_BANK_IN_ACK             [num_bank] = true;
+                  internal_BANK_IN_NUM_RENAME_UNIT [num_bank] = num_rename_unit;
+                  internal_BANK_IN_NUM_INST        [num_bank] = num_inst_rename;
+		  
+                  break; // Stop scan
+                }
+              else
+                log_printf(TRACE,Issue_queue,FUNCTION,"    * not find");
+            }
+        }
+    
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
+          PORT_WRITE(out_ISSUE_IN_ACK [i][j],ack [i][j]);
+    }
+
+    // ===================================================================
+    // =====[ ISSUE_OUT ]=================================================
+    // ===================================================================
+    {
+      Tcontrol_t val [_param->_nb_inst_issue];
+
+      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+        val [i] = 0;
+
+      // From Reexecute_queue
+
+//       uint32_t num_reexecute_entry = 0;
+      for (std::list<entry_t*>::iterator it=_reexecute_queue.begin();
+           it!=_reexecute_queue.end();
+           ++it)
+        {
+          entry_t* entry = (*it);
+
+          for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+            // test if no previous transaction and can accept this type
+            if ((val[i] == 0) and _param->_table_issue_type [i][entry->_type])
+              {
+                // find a issue port
+                val [i] = 1;
+	    
+                if (_param->_have_port_context_id)
+	        PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
+	        if (_param->_have_port_front_end_id)
+	        PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
+	        if (_param->_have_port_rob_ptr  )
+	        PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
+	        PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
+	        PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
+	        PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
+	        if (_param->_have_port_load_queue_ptr)
+	        PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
+	        PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
+	        PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
+	        PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
+	        PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
+	        PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
+	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
+
+                internal_ISSUE_OUT_FROM_REEXECUTE [i] = true;
+//              internal_ISSUE_OUT_NUM_BANK       [i] = num_reexecute_entry;
+                internal_ISSUE_OUT_ENTRY          [i] = entry;
+
+                break; // stop scan
+              }
+//           num_reexecute_entry ++;
+        }
+
+      // From Issue_queue
+
+      std::list<generic::priority::select_t> * select = _priority_out->select(); // same select for all issue
+
+      for (std::list<generic::priority::select_t>::iterator it=select->begin();
+           it!=select->end();
+           it++)
+        {
+          uint32_t num_bank=it->grp;
+
+//        log_printf(TRACE,Issue_queue,Issue_queue,FUNCTION,"    * Bank [%d]",num_bank);
+
+          // Have instruction ?
+          if (not _issue_queue [num_bank].empty())
+            {
+// 	      log_printf(TRACE,Issue_queue,Issue_queue,FUNCTION,"      * Not Empty !!!");
+
+              entry_t* entry = _issue_queue [num_bank].front();
+              
+              for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+                // test if no previous transaction and can accept this type
+                if ((val[i] == 0) and _param->_table_issue_type [i][entry->_type])
+                  {
+                    // find a issue port
+                    val [i] = 1;
+
+                    if (_param->_have_port_context_id)
+	            PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
+	            if (_param->_have_port_front_end_id)
+	            PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
+	            if (_param->_have_port_rob_ptr  )
+	            PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
+	            PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
+	            PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
+	            PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
+	            if (_param->_have_port_load_queue_ptr)
+	            PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
+	            PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
+	            PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
+	            PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
+	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
+	            PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
+	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
+	            PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
+	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
+	            PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
+	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
+	            PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
+	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
+                    
+                    internal_ISSUE_OUT_FROM_REEXECUTE [i] = false;
+                    internal_ISSUE_OUT_NUM_BANK       [i] = num_bank;
+                    internal_ISSUE_OUT_ENTRY          [i] = entry;
+
+                    break; // stop scan
+                  }
+            }
+        }
+
+      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
+        {
+          internal_ISSUE_OUT_VAL [i] = val [i];
+          PORT_WRITE(out_ISSUE_OUT_VAL [i], internal_ISSUE_OUT_VAL [i]);
+        }
+    }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_function_out_of_order_transition.cpp	(revision 111)
@@ -0,0 +1,116 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::function_out_of_order_transition"
+  void Issue_queue::function_out_of_order_transition (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+// 	_priority_in ->reset();
+	_priority_out->reset();
+	_priority_reg->reset();
+	
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  _issue_queue [i].clear();
+      }
+    else
+      {
+// 	_priority_in ->transition();
+ 	_priority_out->transition();
+	_priority_reg->transition();
+
+	// ===================================================================
+	// =====[ ISSUE_IN ]==================================================
+	// ===================================================================
+
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  if (internal_BANK_IN_ACK [i])
+	    {
+              uint32_t x = internal_BANK_IN_NUM_RENAME_UNIT [i];
+              uint32_t y = internal_BANK_IN_NUM_INST [i];
+              
+              if (PORT_READ(in_ISSUE_IN_VAL[x][y]))
+                {
+                  log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d] - Transaction with ISSUE_IN [%d][%d]",i,x,y);
+
+#ifdef STATISTICS
+                  if (usage_is_set(_usage,USE_STATISTICS))
+                    (*_stat_nb_inst_issue_in [x]) ++;
+#endif
+                  entry_t * entry = new entry_t
+                    (
+                     (_param->_have_port_context_id    )?PORT_READ(in_ISSUE_IN_CONTEXT_ID            [x][y]):0,
+                     (_param->_have_port_front_end_id  )?PORT_READ(in_ISSUE_IN_FRONT_END_ID          [x][y]):0,
+                     (_param->_have_port_rob_ptr       )?PORT_READ(in_ISSUE_IN_PACKET_ID             [x][y]):0,
+			                                 PORT_READ(in_ISSUE_IN_OPERATION             [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_TYPE                  [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_STORE_QUEUE_PTR_WRITE [x][y]),
+                     (_param->_have_port_load_queue_ptr)?PORT_READ(in_ISSUE_IN_LOAD_QUEUE_PTR_WRITE  [x][y]):0,
+			                                 PORT_READ(in_ISSUE_IN_HAS_IMMEDIAT          [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_IMMEDIAT              [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_READ_RA               [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RA            [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_READ_RB               [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RB            [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_READ_RC               [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RC            [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_WRITE_RD              [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RD            [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_WRITE_RE              [x][y]),
+			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RE            [x][y])
+                     );
+
+                  _issue_queue [i].push_back(entry);
+                }
+	    }
+
+	// ===================================================================
+	// =====[ ISSUE_OUT ]=================================================
+	// ===================================================================
+
+        for (uint32_t i=0; i<_param->_nb_inst_issue; ++i)
+          if (internal_ISSUE_OUT_VAL [i] and PORT_READ(in_ISSUE_OUT_ACK [i]))
+            if (not internal_ISSUE_OUT_FROM_REEXECUTE [i])
+              {
+                entry_t * entry = internal_ISSUE_OUT_ENTRY    [i];
+                
+                // front ...
+                uint32_t  num_bank = internal_ISSUE_OUT_NUM_BANK [i];
+                
+                log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_OUT [%d] - From issue_queue [%d]",i,num_bank);
+                
+                _issue_queue [num_bank].remove(entry);
+                delete entry;
+              } 
+      }
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_in.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_in.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_in.cpp	(revision 111)
@@ -0,0 +1,38 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::genMealy_issue_in"
+  void Issue_queue::genMealy_issue_in (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    (this->*function_genMealy_issue_in) ();
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_out.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMealy_issue_out.cpp	(revision 111)
@@ -0,0 +1,38 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/include/Issue_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace issue_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Issue_queue::genMealy_issue_out"
+  void Issue_queue::genMealy_issue_out (void)
+  {
+    log_begin(Issue_queue,FUNCTION);
+    log_function(Issue_queue,FUNCTION,_name.c_str());
+
+    (this->*function_genMealy_issue_out) ();
+
+    log_end(Issue_queue,FUNCTION);
+  };
+
+}; // end namespace issue_queue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_genMoore.cpp	(revision 111)
@@ -39,187 +39,5 @@
       }
 
-    // ===================================================================
-    // =====[ ISSUE_IN ]==================================================
-    // ===================================================================
-    {
-      Tcontrol_t ack [_param->_nb_rename_unit][_param->_max_nb_inst_rename];
-
-      // Initialisation
-      for (uint32_t i=0; i<_param->_nb_bank; i++)
-        internal_BANK_IN_ACK  [i] = false;
-    
-      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
-        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
-          ack [i][j] = false;
-    
-      std::list<generic::priority::select_t> * select_reg = _priority_reg->select(); // same select for all issue
-      
-      // issue_in interface
-      std::list<generic::priority::select_t> * select_in = _priority_in ->select(); // same select for all issue
-      for (std::list<generic::priority::select_t>::iterator it=select_in ->begin();
-           it!=select_in ->end();
-           it++)
-        {
-          // Get num interface
-          uint32_t num_rename_unit = it->grp;
-          uint32_t num_inst_rename = it->elt;
-
-          log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d][%d]",num_rename_unit,num_inst_rename);
-          
-          // scan all bank
-          for (std::list<generic::priority::select_t>::iterator it=select_reg->begin();
-               it!=select_reg->end();
-               it++)
-            {
-              uint32_t num_bank  = it->grp;
-
-              log_printf(TRACE,Issue_queue,FUNCTION,"    * BANK [%d]",num_bank);
-          
-              // test if bank is not busy (full or previous access)
-              if (not internal_BANK_IN_ACK [num_bank] and (_issue_queue[num_bank].size() < _param->_size_bank))
-                {
-                  log_printf(TRACE,Issue_queue,FUNCTION,"    * find");
-
-                  // find
-                  ack [num_rename_unit][num_inst_rename] = true;
-                  internal_BANK_IN_ACK             [num_bank] = true;
-                  internal_BANK_IN_NUM_RENAME_UNIT [num_bank] = num_rename_unit;
-                  internal_BANK_IN_NUM_INST        [num_bank] = num_inst_rename;
-		  
-                  break; // Stop scan
-                }
-              else
-                log_printf(TRACE,Issue_queue,FUNCTION,"    * not find");
-            }
-        }
-    
-      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
-        for (uint32_t j=0; j<_param->_nb_inst_rename[i]; j++)
-          PORT_WRITE(out_ISSUE_IN_ACK [i][j],ack [i][j]);
-    }
-
-    // ===================================================================
-    // =====[ ISSUE_OUT ]=================================================
-    // ===================================================================
-    {
-      Tcontrol_t val [_param->_nb_inst_issue];
-
-      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
-        val [i] = 0;
-
-      // From Reexecute_queue
-
-//       uint32_t num_reexecute_entry = 0;
-      for (std::list<entry_t*>::iterator it=_reexecute_queue.begin();
-           it!=_reexecute_queue.end();
-           ++it)
-        {
-          entry_t* entry = (*it);
-
-          for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
-            // test if no previous transaction and can accept this type
-            if ((val[i] == 0) and _param->_table_issue_type [i][entry->_type])
-              {
-                // find a issue port
-                val [i] = 1;
-	    
-                if (_param->_have_port_context_id)
-	        PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
-	        if (_param->_have_port_front_end_id)
-	        PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
-	        if (_param->_have_port_rob_ptr  )
-	        PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
-	        PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
-	        PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
-	        PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
-	        if (_param->_have_port_load_queue_ptr)
-	        PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
-	        PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
-	        PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
-	        PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
-	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
-	        PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
-	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
-	        PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
-	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
-	        PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
-	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
-	        PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
-	        PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
-
-                internal_ISSUE_OUT_FROM_REEXECUTE [i] = true;
-//              internal_ISSUE_OUT_NUM_BANK       [i] = num_reexecute_entry;
-                internal_ISSUE_OUT_ENTRY          [i] = entry;
-
-                break; // stop scan
-              }
-//           num_reexecute_entry ++;
-        }
-
-      // From Issue_queue
-
-      std::list<generic::priority::select_t> * select = _priority_out->select(); // same select for all issue
-
-      for (std::list<generic::priority::select_t>::iterator it=select->begin();
-           it!=select->end();
-           it++)
-        {
-          uint32_t num_bank=it->grp;
-
-//        log_printf(TRACE,Issue_queue,Issue_queue,FUNCTION,"    * Bank [%d]",num_bank);
-
-          // Have instruction ?
-          if (not _issue_queue [num_bank].empty())
-            {
-// 	      log_printf(TRACE,Issue_queue,Issue_queue,FUNCTION,"      * Not Empty !!!");
-
-              entry_t* entry = _issue_queue [num_bank].front();
-              
-              for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
-                // test if no previous transaction and can accept this type
-                if ((val[i] == 0) and _param->_table_issue_type [i][entry->_type])
-                  {
-                    // find a issue port
-                    val [i] = 1;
-
-                    if (_param->_have_port_context_id)
-	            PORT_WRITE(out_ISSUE_OUT_CONTEXT_ID            [i], entry->_context_id           );
-	            if (_param->_have_port_front_end_id)
-	            PORT_WRITE(out_ISSUE_OUT_FRONT_END_ID          [i], entry->_front_end_id         );
-	            if (_param->_have_port_rob_ptr  )
-	            PORT_WRITE(out_ISSUE_OUT_PACKET_ID             [i], entry->_packet_id            );
-	            PORT_WRITE(out_ISSUE_OUT_OPERATION             [i], entry->_operation            );
-	            PORT_WRITE(out_ISSUE_OUT_TYPE                  [i], entry->_type                 );
-	            PORT_WRITE(out_ISSUE_OUT_STORE_QUEUE_PTR_WRITE [i], entry->_store_queue_ptr_write);
-	            if (_param->_have_port_load_queue_ptr)
-	            PORT_WRITE(out_ISSUE_OUT_LOAD_QUEUE_PTR_WRITE  [i], entry->_load_queue_ptr_write );
-	            PORT_WRITE(out_ISSUE_OUT_HAS_IMMEDIAT          [i], entry->_has_immediat         );
-	            PORT_WRITE(out_ISSUE_OUT_IMMEDIAT              [i], entry->_immediat             );
-	            PORT_WRITE(out_ISSUE_OUT_READ_RA               [i], entry->_read_ra              );
-	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RA            [i], entry->_num_reg_ra           );
-	            PORT_WRITE(out_ISSUE_OUT_READ_RB               [i], entry->_read_rb              );
-	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RB            [i], entry->_num_reg_rb           );
-	            PORT_WRITE(out_ISSUE_OUT_READ_RC               [i], entry->_read_rc              );
-	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RC            [i], entry->_num_reg_rc           );
-	            PORT_WRITE(out_ISSUE_OUT_WRITE_RD              [i], entry->_write_rd             );
-	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RD            [i], entry->_num_reg_rd           );
-	            PORT_WRITE(out_ISSUE_OUT_WRITE_RE              [i], entry->_write_re             );
-	            PORT_WRITE(out_ISSUE_OUT_NUM_REG_RE            [i], entry->_num_reg_re           );
-                    
-                    internal_ISSUE_OUT_FROM_REEXECUTE [i] = false;
-                    internal_ISSUE_OUT_NUM_BANK       [i] = num_bank;
-                    internal_ISSUE_OUT_ENTRY          [i] = entry;
-
-                    break; // stop scan
-                  }
-            }
-        }
-
-      for (uint32_t i=0; i<_param->_nb_inst_issue; i++)
-        {
-          internal_ISSUE_OUT_VAL [i] = val [i];
-          PORT_WRITE(out_ISSUE_OUT_VAL [i], internal_ISSUE_OUT_VAL [i]);
-        }
-    }
+    (this->*function_genMoore) ();
 
     log_end(Issue_queue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Issue_queue_transition.cpp	(revision 111)
@@ -27,9 +27,4 @@
       {
 	_priority_in ->reset();
-	_priority_out->reset();
-	_priority_reg->reset();
-	
-	for (uint32_t i=0; i<_param->_nb_bank; i++)
-	  _issue_queue [i].clear();
         _reexecute_queue.clear();
       }
@@ -37,51 +32,4 @@
       {
 	_priority_in ->transition();
-	_priority_out->transition();
-	_priority_reg->transition();
-
-	// ===================================================================
-	// =====[ ISSUE_IN ]==================================================
-	// ===================================================================
-
-	for (uint32_t i=0; i<_param->_nb_bank; i++)
-	  if (internal_BANK_IN_ACK [i])
-	    {
-              uint32_t x = internal_BANK_IN_NUM_RENAME_UNIT [i];
-              uint32_t y = internal_BANK_IN_NUM_INST [i];
-              
-              if (PORT_READ(in_ISSUE_IN_VAL[x][y]))
-                {
-                  log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_IN [%d] - Transaction with ISSUE_IN [%d][%d]",i,x,y);
-
-#ifdef STATISTICS
-                  if (usage_is_set(_usage,USE_STATISTICS))
-                    (*_stat_nb_inst_issue_in [x]) ++;
-#endif
-                  entry_t * entry = new entry_t
-                    (
-                     (_param->_have_port_context_id    )?PORT_READ(in_ISSUE_IN_CONTEXT_ID            [x][y]):0,
-                     (_param->_have_port_front_end_id  )?PORT_READ(in_ISSUE_IN_FRONT_END_ID          [x][y]):0,
-                     (_param->_have_port_rob_ptr       )?PORT_READ(in_ISSUE_IN_PACKET_ID             [x][y]):0,
-			                                 PORT_READ(in_ISSUE_IN_OPERATION             [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_TYPE                  [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_STORE_QUEUE_PTR_WRITE [x][y]),
-                     (_param->_have_port_load_queue_ptr)?PORT_READ(in_ISSUE_IN_LOAD_QUEUE_PTR_WRITE  [x][y]):0,
-			                                 PORT_READ(in_ISSUE_IN_HAS_IMMEDIAT          [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_IMMEDIAT              [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_READ_RA               [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RA            [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_READ_RB               [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RB            [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_READ_RC               [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RC            [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_WRITE_RD              [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RD            [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_WRITE_RE              [x][y]),
-			                                 PORT_READ(in_ISSUE_IN_NUM_REG_RE            [x][y])
-                     );
-
-                  _issue_queue [i].push_back(entry);
-                }
-	    }
 
 	// ===================================================================
@@ -130,27 +78,30 @@
           if (internal_ISSUE_OUT_VAL [i] and PORT_READ(in_ISSUE_OUT_ACK [i]))
             {
-              entry_t * entry    = internal_ISSUE_OUT_ENTRY    [i];
-
+#ifdef STATISTICS
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*_stat_nb_inst_issue_out ) ++;
+#endif
               if (internal_ISSUE_OUT_FROM_REEXECUTE [i])
                 {
+                  entry_t * entry = internal_ISSUE_OUT_ENTRY    [i];
+                  
                   log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_OUT [%d] - From Reexecute_queue",i);
                   
                   _reexecute_queue.remove(entry);
+                  
+                  delete entry;
                 }
-              else
-                {
-                  // front ...
-                  uint32_t  num_bank = internal_ISSUE_OUT_NUM_BANK [i];
-
-                  log_printf(TRACE,Issue_queue,FUNCTION,"  * ISSUE_OUT [%d] - From issue_queue [%d]",i,num_bank);
-
-                  _issue_queue [num_bank].remove(entry);
-                }
-
-              delete entry;
-            } 
+                // else ... in function specific
+            }
       }
 
-#if defined(DEBUG) and defined(DEBUG_Issue_queue) and (DEBUG >= DEBUG_TRACE)
+    // specific implementation
+    (this->*function_transition) ();
+
+    // ===================================================================
+    // =====[ PRINT ]====================================================
+    // ===================================================================
+
+#if defined(DEBUG) and DEBUG_Issue_queue and (DEBUG >= DEBUG_TRACE)
     log_printf(TRACE,Issue_queue,FUNCTION,"  * Dump Issue_queue");
 
@@ -245,4 +196,6 @@
 #endif
 
+
+
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
     end_cycle ();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters.cpp	(revision 111)
@@ -19,25 +19,26 @@
 #undef  FUNCTION
 #define FUNCTION "Issue_queue::Parameters"
-  Parameters::Parameters (uint32_t          nb_context              ,
-			  uint32_t          nb_front_end            ,
-			  uint32_t          nb_rename_unit          ,
-			  uint32_t          size_queue              ,
-			  uint32_t          nb_bank                 ,
-			  uint32_t          size_packet             ,
-			  uint32_t          size_general_data       ,
-			  uint32_t          size_special_data       ,
-			  uint32_t          size_general_register   ,
-			  uint32_t          size_special_register   ,
-			  uint32_t          size_store_queue_ptr    ,
-			  uint32_t          size_load_queue_ptr     ,
-			  uint32_t          nb_inst_issue           ,
-			  uint32_t        * nb_inst_rename          ,
-			  uint32_t          nb_inst_reexecute       ,
-			  uint32_t          nb_rename_unit_select   ,
-			  Tpriority_t       priority                ,
-			  Tload_balancing_t load_balancing          ,
-			  bool           ** table_routing           ,
-			  bool           ** table_issue_type        ,
-                          bool              is_toplevel             )
+  Parameters::Parameters (uint32_t              nb_context              ,
+			  uint32_t              nb_front_end            ,
+			  uint32_t              nb_rename_unit          ,
+			  uint32_t              size_queue              ,
+                          Tissue_queue_scheme_t queue_scheme            ,
+			  uint32_t              nb_bank                 ,
+			  uint32_t              size_packet             ,
+			  uint32_t              size_general_data       ,
+			  uint32_t              size_special_data       ,
+			  uint32_t              size_general_register   ,
+			  uint32_t              size_special_register   ,
+			  uint32_t              size_store_queue_ptr    ,
+			  uint32_t              size_load_queue_ptr     ,
+			  uint32_t              nb_inst_issue           ,
+			  uint32_t            * nb_inst_rename          ,
+			  uint32_t              nb_inst_reexecute       ,
+			  uint32_t              nb_rename_unit_select   ,
+			  Tpriority_t           priority                ,
+			  Tload_balancing_t     load_balancing          ,
+			  bool               ** table_routing           ,
+			  bool               ** table_issue_type        ,
+                          bool                  is_toplevel             )
   {
     log_begin(Issue_queue,FUNCTION);
@@ -47,4 +48,5 @@
     _nb_rename_unit           = nb_rename_unit       ;
     _size_queue               = size_queue           ;
+    _queue_scheme             = queue_scheme         ;
     _nb_bank                  = nb_bank              ;   
     _nb_inst_issue            = nb_inst_issue        ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Issue_queue/src/Parameters_msg_error.cpp	(revision 111)
@@ -25,4 +25,23 @@
 
     Parameters_test test ("Issue_queue");
+
+    switch (_queue_scheme)
+      {
+      case ISSUE_QUEUE_SCHEME_IN_ORDER        :
+      case ISSUE_QUEUE_SCHEME_OUT_OF_ORDER    :
+	{
+          // supported
+	  break;
+	}
+      default :
+	{
+	  test.error(toString(_("Issue queue scheme '%s' is not supported. Please wait a next revision.\n"),toString(_queue_scheme).c_str()));
+	  break;
+	}
+      }
+
+    if (// (_queue_scheme == ISSUE_QUEUE_SCHEME_IN_BUNDLE_ORDER) or
+        (_queue_scheme == ISSUE_QUEUE_SCHEME_OUT_OF_ORDER   ))
+      test.warning(toString(_("Can have deadlock with the queue scheme \"%s\".\n"),toString(_queue_scheme).c_str()));
 
     if (not is_multiple(_size_queue, _nb_bank))
